"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _defaultProps = _interopRequireDefault(require("./props/defaultProps"));

var _propTypes = require("./props/propTypes");

var _cssJSLogic2 = _interopRequireDefault(require("./css/cssJSLogic"));

var _utils = require("@zohodesk/utils");

var _contants = require("./contants");

var _Flex = _interopRequireDefault(require("@zohodesk/layout/es/Flex/Flex"));

var _Label = _interopRequireDefault(require("../../Label/Label"));

var _Switch_v2Module = _interopRequireDefault(require("./css/Switch_v2.module.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Switch = function Switch(props) {
  var name = props.name,
      value = props.value,
      id = props.id,
      size = props.size,
      isChecked = props.isChecked,
      isDisabled = props.isDisabled,
      isReadOnly = props.isReadOnly,
      onChange = props.onChange,
      hasOnOffIndication = props.hasOnOffIndication,
      labelText = props.labelText,
      labelPalette = props.labelPalette,
      labelPlacement = props.labelPlacement,
      labelSize = props.labelSize,
      title = props.title,
      customProps_container = props.customProps_container,
      customProps_label = props.customProps_label,
      tagAttributes_container = props.tagAttributes_container,
      tagAttributes_switch = props.tagAttributes_switch,
      a11yAttributes_container = props.a11yAttributes_container,
      a11yAttributes_switch = props.a11yAttributes_switch,
      a11yAttributes_label = props.a11yAttributes_label,
      customId = props.customId,
      testId = props.testId,
      customStyle = props.customStyle;
  var _a11yAttributes_switc = a11yAttributes_switch.role,
      role = _a11yAttributes_switc === void 0 ? 'switch' : _a11yAttributes_switc,
      extraA11yAttributes_switch = a11yAttributes_switch.extraA11yAttributes_switch;
  var style = (0, _utils.mergeStyle)(_Switch_v2Module["default"], customStyle);

  var _cssJSLogic = (0, _cssJSLogic2["default"])({
    props: props,
    style: style
  }),
      containerClass = _cssJSLogic.containerClass,
      labelClass = _cssJSLogic.labelClass,
      trackClass = _cssJSLogic.trackClass,
      trackWrapperClass = _cssJSLogic.trackWrapperClass,
      thumbClass = _cssJSLogic.thumbClass,
      labelIndicationClass = _cssJSLogic.labelIndicationClass;

  return /*#__PURE__*/_react["default"].createElement(_Flex["default"], _extends({
    $ui_displayMode: "inline",
    $ui_direction: labelPlacement === 'left' ? 'row' : 'rowReverse',
    $ui_alignItems: "center",
    $tagAttributes_container: _objectSpread({
      'data-selector-id': customId
    }, tagAttributes_container),
    testId: testId,
    customId: customId,
    customStyle: {
      inlineFlex: containerClass
    },
    $a11yAttributes_container: a11yAttributes_container
  }, customProps_container), labelText && /*#__PURE__*/_react["default"].createElement(_Label["default"], _extends({
    text: labelText,
    palette: labelPalette,
    size: labelSize,
    htmlFor: id,
    customClass: labelClass,
    a11y: a11yAttributes_label
  }, customProps_label)), /*#__PURE__*/_react["default"].createElement(_Flex["default"], {
    $flag_shrink: false,
    customStyle: {
      noShrink: trackWrapperClass
    }
  }, /*#__PURE__*/_react["default"].createElement("input", _extends({
    type: "checkbox",
    id: id,
    name: name,
    value: value,
    checked: isChecked,
    disabled: isDisabled,
    readOnly: isReadOnly,
    onClick: !isDisabled || !isReadOnly ? onChange : null,
    role: role,
    className: trackClass,
    "data-title": title
  }, tagAttributes_switch, extraA11yAttributes_switch)), /*#__PURE__*/_react["default"].createElement("svg", {
    className: thumbClass,
    xmlns: "http://www.w3.org/2000/svg"
  }, /*#__PURE__*/_react["default"].createElement("circle", {
    cx: "50%",
    cy: "50%",
    r: _contants.thumbRadius[size]
  })), hasOnOffIndication ? /*#__PURE__*/_react["default"].createElement("svg", {
    className: labelIndicationClass,
    xmlns: "http://www.w3.org/2000/svg"
  }, isChecked ? /*#__PURE__*/_react["default"].createElement("rect", {
    width: "100%",
    height: "100%",
    rx: "50%"
  }) : /*#__PURE__*/_react["default"].createElement("circle", {
    cx: "50%",
    cy: "50%",
    r: _contants.offLabelRadius[size]
  })) : null));
};

var _default = Switch;
exports["default"] = _default;
Switch.defaultProps = _defaultProps["default"];
Switch.propTypes = _propTypes.propTypes;